#include "button.h"

uint8_t button::released;
uint32_t button::mS;

ISR(INT0_vect) { // logical change occurred on pin 2
  button::mS = millis();
  button::released = PIND & 0x04; // released will have value 4 (true) or 0 (false)
}

void button::start(void) {
    pinMode(2, INPUT_PULLUP);
    released = 4; // set button released state till first edge occurs
    EICRA = 0x01; // any logical change on pin 2 generates interrupt
    EIMSK = 0x01; // allow pin 2 pinchange interrupt
}

uint32_t button::milliseconds(uint8_t *buttonUp) {
  cli();
  *buttonUp = released;
  uint32_t t = millis() - mS;
  sei();
  return t;
}

