#include "eeprom.h"

globalData eeprom::gd;
modelData eeprom::md;
char eeprom::modelName[14];

void eeprom::limitModelNumber(uint8_t *modelNumber) {
  if (*modelNumber < 1) *modelNumber = 1;
  if (*modelNumber > 27) *modelNumber = 27;
}

void eeprom::getGD(void) {
  EEPROM.get(0, gd);
  limitModelNumber(&(gd.modelNum));
}

void eeprom::putGD(void) {
  limitModelNumber(&(gd.modelNum));
  EEPROM.put(0, gd);
}

void eeprom::getMD(uint8_t modelNumber) {
  limitModelNumber(&modelNumber);
  EEPROM.get(37 * modelNumber - 12, md);
}

void eeprom::putMD(uint8_t modelNumber) {
  limitModelNumber(&modelNumber);
  EEPROM.put(37 * modelNumber - 12, md);
}

char *eeprom::getModelName(uint8_t modelNumber) {
  for (int16_t i = 0; i < 13; i++)
    modelName[i] = (char)EEPROM.read(i + 37 * modelNumber - 12);
  modelName[13] = '\0';
  return modelName;
}

