#ifndef joystick_h
#define joystick_h

#include <Arduino.h>

class joystick { // x axis on A0, y axis on A1, joystick pressed on 10
  private:
  static int16_t autoRepeat;
  static int16_t debounce;
  static int16_t buttonDebounce[4];
  static boolean digital;
  
  public:
  static void start(boolean digital); // digital is true for button joystick, false for analogue version
  static int16_t axis[2]; // axis[0] is x (right +ve) scaled to -512 0 512.  axis[1] is y (down (i.e. up elevator) +ve
  static uint8_t button; // bits 0, 1, 2, 3, 4 = right, left, down, up, pressed
  static uint8_t increment; // allows for speed-up on auto-repeat - for example when editing uS pulse times
  static int16_t timeout; // resets to 30,000 when joystick moved - counts down elapsed mS when idle - reaches zero after 30 seconds inactivity
  static void readJoy(uint16_t mS); // mS is milliseconds since previous read  
};

#endif
